<?
	/*
		post.php
		Bestandteil des Firebooks
		[WMP] Guestbook Contest
		(c) 2003 by Firebird
		
		Dieses Programm ist freie Software. 
		Sie knnen es unter den Bedingungen der GNU General Public License,
		wie von der Free Software Foundation verffentlicht,
		weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz
		oder (nach Ihrer Option) jeder spteren Version. 
		
		Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
		da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
		sogar ohne die implizite Garantie der MARKTREIFE oder der
		VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in
		der GNU General Public License. 
	*/
	require("global.php");
	
	// Editid fr das Editieren von Beitrgen
	$editid = "NICHTS";
	
	// Voreinstellungen treffen, damit die Templates richtig angezeigt werden
	$Checkbox = array();
	$Entry = array();
	$message = "";
	$invalid_marker = array();
	$Checkbox['GBCode'] = ($Settings['allowgbc'] == 1 ? "checked" : "disabled");
	$Checkbox['HTML'] = ($Settings['allowhtml'] == 1 ? "checked" : "disabled");
	$Checkbox['Smilies'] = ($Settings['allowsmilies'] == 1 ? "checked" : "disabled");
	foreach($Fields as $Field)
	{	
		$invalid_marker[$Field['Name']] = "false";
		$Entry[$Field['Name']] = "";
	}
	$invalid_marker['message'] = "false";
	$preview = "";
	$invalid_message = "";
	
	// Lschen
	if(isset($_GET['delete']))
	{
		// Eintrag laden, Rechte abfragen, ndern & Speichern
		$delete = $_GET['delete'];
		if($delete == "NICHTS") die("<script type='text/javascript'>window.history.back();</script>");
		needRights($delete);
		unset($Entrys[$delete]);
		saveSettings();
		header("Location: index.php");
		die();
	}	
	// Bearbeiten
	if(isset($_GET['edit']))
	{
		// Eintrag laden
		$edit = $_GET['edit'];
		if($edit == "NICHTS") die("<script type='text/javascript'>window.history.back();</script>");
		$editid = $edit;
		// Rechte abfragen
		needRights($edit);
		
		// Einstellungen laden
		$editEntry = &$Entrys[$edit];
		$Checkbox = array();
		
		// Checkboxen voreinstellen
		$Checkbox['GBCode'] = ($editEntry['GBCode'] == 1 ? "checked" : "")." ".($Settings['allowgbc'] == 1 ? "" : "disabled");
		$Checkbox['HTML'] = ($editEntry['HTML'] == 1 ? "checked" : "")." ".($Settings['allowhtml'] == 1 ? "" : "disabled");
		$Checkbox['Smilies'] = ($editEntry['Smilies'] == 1 ? "checked" : "")." ".($Settings['allowsmilies'] == 1 ? "" : "disabled");
		
		// Nachricht laden
		$message = $editEntry['Message'];
		$Entry = $editEntry['Fields'];
	}
	
	if(isset($_POST['Action']))
	{
		// Code validieren
		
		// Backup fr evntl. Fehler erstellen
		if(isset($_POST['message'])) $_POST['message'] = applyWordWrap($_POST['message']);
		if(isset($_POST['message'])) $message = $_POST['message'];
		$Entry = $_POST;
		
		// Falls ein Fehler auftritt wird die Seite wieder angezeigt. Checkbox muss dann einen Wert haben
		$Checkbox = array();
		$Checkbox['GBCode'] = (isset($_POST['GBCode']) && $_POST['GBCode'] == 1 ? "checked" : "")." ".($Settings['allowgbc'] == 1 ? "" : "disabled");
		$Checkbox['HTML'] = (isset($_POST['HTML']) && $_POST['HTML'] == 1 ? "checked" : "")." ".($Settings['allowhtml'] == 1 ? "" : "disabled");
		$Checkbox['Smilies'] = (isset($_POST['Smilies']) && $_POST['Smilies'] == 1 ? "checked" : "")." ".($Settings['allowsmilies'] == 1 ? "" : "disabled");
		
		// Editid laden, wenn sie angegeben wurde
		unset($editid);
		if(isset($_POST['editid'])) $editid = $_POST['editid'];
		if(isset($editid) && $editid == "NICHTS") unset($editid);
		
		// Rechte berprfen
		if(isset($editid)) needRights($editid);
		
		// Eintrag zum Speichern vorbereiten
		if(isset($editid))
		{
			// Einstellungen bernehmen
			$myNewEntry = $Entrys[$editid];
		}
		else
		{
			// Einstellungen neu erstellen
			$myNewEntry = array();
			$myNewEntry['IP'] = $_SERVER['REMOTE_ADDR'];
			$myNewEntry['Time'] = time();
			
			// Moderation
			if($Settings['moderation'] == 1 && (!gotAdminRights()))
				$myNewEntry['activationkey'] = md5(uniqid(rand()));
		}
		
		$myNewEntry['GBCode'] = (isset($_POST['GBCode']) ? 1 : 0);
		$myNewEntry['HTML'] = (isset($_POST['HTML']) ? 1 : 0);
		$myNewEntry['Smilies'] = (isset($_POST['Smilies']) ? 1 : 0);
		$myNewEntry['Message'] = applyWordWrap($_POST['message']);
		
		
		
		// Validieren
		$invalid = 0;
		foreach($Fields as $Field)
		{
			// Typ: array("Name" => "Nick", "Validation" => "", "Min" => 1, "Max" => 255);
			// Wert laden
			$value = trim($_POST[$Field['Name']]);
			$myNewEntry['Fields'][$Field['Name']] = $value;
			
			// Validieren ber REGEX
			if(strlen($value) > 0 && $Field['Validation'] != "" && !preg_match($Field['Validation'], $value))
			{
				$invalid = 1; 
				$invalid_marker[$Field['Name']] = "true";
			}
			// Zu kurz ..?
			if($Field['Min'] != 0 && strlen($value) < $Field['Min'])
			{
				$invalid = 1; 
				$invalid_marker[$Field['Name']] = "true";
			}
			// Zu lang ..?
			if($Field['Max'] != 0 && strlen($value) > $Field['Max'])
			{
				$invalid = 1; 
				$invalid_marker[$Field['Name']] = "true";
			} 
		}
		// Nachrichtenlnge prfen
		if(strlen($_POST['message']) > $Settings['max_length'])
		{
			$invalid = 1; 
			$invalid_marker['message'] = "true";
		}
		
		if($invalid == 1)
			// Ungltig, abbrechen
			eval("\$invalid_message = \"".getTPL("enterform_invalid")."\";");
	}
	
	if(isset($_POST['Action']) && $_POST['Action'] == "Vorschau")
	{
		// Vorschau erstellen
		// Einstellungen laden
		if(isset($_POST['message'])) $_POST['message'] = applyWordWrap($_POST['message']);
		if(isset($_POST['message'])) $message = $_POST['message'];
		$Entry = $_POST;
		
		
		$Checkbox = array();
		$Checkbox['GBCode'] = (isset($_POST['GBCode']) && $_POST['GBCode'] == 1 ? "checked" : "")." ".($Settings['allowgbc'] == 1 ? "" : "disabled");
		$Checkbox['HTML'] = (isset($_POST['HTML']) && $_POST['HTML'] == 1 ? "checked" : "")." ".($Settings['allowhtml'] == 1 ? "" : "disabled");
		$Checkbox['Smilies'] = (isset($_POST['Smilies']) && $_POST['Smilies'] == 1 ? "checked" : "")." ".($Settings['allowsmilies'] == 1 ? "" : "disabled");
		
		$prevEntry = array();
		$prevEntry = $_POST;
		$prevEntry['Message'] = $prevEntry['message'];
		
		// Eintrag parsen
		$Preview = parseEntry($prevEntry, "NICHTS");
		eval("\$preview = \"".getTPL("enterform_previewtext")."\";");
	}
	
	
	if(isset($_POST['Action']) && $_POST['Action'] == "Abschicken" && isset($invalid) && $invalid == 0)
	{
		// Code speichern
		
		// Versucht da jemand den Admin-Account zu benutzen? Dafr braucht er auch das Passwort...
		if(isset($myNewEntry['Fields']['Nick']) && $myNewEntry['Fields']['Nick'] == $Settings['adminuser'])
			needAdminRights("Admin Nick benutzen");
						
		// Editieren oder Speichern?
		if(!isset($editid))
		{
			// Speichern.
			
			// Flooding Kontrolle
			if($Settings['floodcontrol'] == 1) IPExisting();
				
			// Eintrag bernehmen
			$Entrys[] = $myNewEntry;
			
			// Neuen Key ermitteln
			foreach($Entrys as $newKey => $tmpNothing) ;
				
			// Settings speichern
			saveSettings();
				
			$baseaddy = "http://".$_SERVER['SERVER_NAME'].str_replace("post.php", "", $_SERVER['SCRIPT_NAME']);
			
			if(isset($Settings['adminicq']) && trim($Settings['adminicq']) != "")
			{
				// Icq Benachrichtigung senden
				icqSendMessage($Settings['adminicq'], "In deinem Gstebuch ist gerade eine neue Nachricht eingegangen");				
			}
			
			if($Settings['sendmailconfirm'] == 1 || isset($myNewEntry['activationkey'])) 
			{
				// Besttigungsmail versenden
				if(isset($myNewEntry['activationkey'])) $activateurl = $baseaddy."misc.php?action=activate&EntryId=".$newKey."&activationcode=".urlencode($myNewEntry['activationkey']);
				$message = parseEntry($myNewEntry, $newKey);
				
				eval("\$confirmmail = \"".getTPL("mail_confirm")."\";");
				mail($Settings['adminmail'], "Neuer Eintrag im Gstebuch", $confirmmail, "Content-Type: text/html\nFrom: Firebook");
			}
			
			// Dankeschn Mail nur wenn es keine Moderation gibt
			if((!isset($myNewEntry['activationkey'])) && $Settings['sendmailthanks'] == 1 && isset($myNewEntry['Fields']['Mail'])) 
			{
				// Dankeschn Mail versenden
				eval("\$thankyoumail = \"".getTPL("mail_thankyou")."\";");
				mail($myNewEntry['Fields']['Mail'], "Danke fr den Eintrag im Gstebuch", $thankyoumail, "Content-Type: text/html\nFrom: Firebook");
			}
			
			
		} else
		{
			// Bearbeiten - Keine Mails, nur durchsenden
			$Entrys[$editid] = $myNewEntry;
			saveSettings();
		}
		// Aktivierungsnachricht senden
		if(isset($myNewEntry['activationkey'])) 
		{
			eval("echo(\"".getTPL("awaiting_moderation")."\");");
			die();
		}
		header("Location: index.php");
	}
	
	if(isset($_GET['quote']))
	{
		// Zitat erstellen
		$zitieren = $_GET['quote'];
		if($zitieren == "NICHTS") die("<script type='text/javascript'>window.history.back();</script>");
		if(isset($Entrys[$zitieren]))
		{
			if(isset($Entrys[$zitieren]['Fields']['Nick']))
				$message = "[quote=".$Entrys[$zitieren]['Fields']['Nick']."]".$Entrys[$zitieren]['Message']."[/quote]";
			else 
				$message = "[quote]".$Entrys[$zitieren]['Message']."[/quote]";
		}
	}
	
	// HTML-Specialchars auf Werte legen
	$message = addHtmlSlashes($message);
	if(isset($Entry)) htmlconvertinarray($Entry);
	
	// Editid bernehmen
	if(isset($_POST['editid'])) $editid = $_POST['editid'];
	
	// Settings laden
	$max_length = $data['SETTINGS']['max_length'];
	
	// Seite parsen
	eval("echo(\"".getTPL("header")."\");");
	eval("echo(\"".getTPL("enterform")."\");");
	eval("echo(\"".getTPL("footer")."\");");
	die();
?>
		