<?
	/*
		incfilestorage.php
		Bestandteil des Firebooks
		[WMP] Guestbook Contest
		(c) 2003 by Firebird
		
		Dieses Programm ist freie Software. 
		Sie knnen es unter den Bedingungen der GNU General Public License,
		wie von der Free Software Foundation verffentlicht,
		weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz
		oder (nach Ihrer Option) jeder spteren Version. 
		
		Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
		da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
		sogar ohne die implizite Garantie der MARKTREIFE oder der
		VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in
		der GNU General Public License. 

	*/
	 	
	$data = array();
	
	// Settings laden
	function loadSettings()
	{
		global $data;
		
		// Existiert berhaupt eine Speicherdatei ? Wenn nicht wird spter das Setup augerufen
		if(!defined("CONST_DATENSPEICHER")) return;
		
		if(file_exists(CONST_DATENSPEICHER))
		{
			// Daten aus der Datei in ein Array laden
			/*
				Info: Als Serialisieren bezeichnetman die Umwandlung eines beliebigen Datentypens
				      in ein speicherbares Format. Array's kann man leicheter verwalten, daher
				      benutze ich sie.
			*/
			$data = unserialize(implode("", file(CONST_DATENSPEICHER)));
		}
		// Else Situation tritt nicht ein
	}
	
	// Settings speichern
	function saveSettings()
	{
		// Daten serialisieren und ab dafr ^^
		global $data;
		$fOutput = fopen(CONST_DATENSPEICHER, "wb");
		fwrite($fOutput, serialize($data));
		fclose($fOutput);
	}
	
	// Settings immer automatisch laden
	loadSettings();
	
	// Standard Subarrays laden
	/*
		Info: Das & Zeichen markiert die Variable als einen Pointer. Auf die Weise ist gewhtleistet,
              dass sich die Inhalte beider Variablen immer entsprechen. ndert man eine,
              ndert sich auch die andere.
	*/
	$Settings = &$data['SETTINGS'];
	$Entrys = &$data['ENTRYS'];
	$Smilies = &$data['SMILIES'];
	$Fields = &$data['FIELDS'];
	$Gbcodes = &$data['GBCODES'];
	$Style = &$data['STYLE'];
?>