<?
	/*
		index.php
		Bestandteil des Firebooks
		[WMP] Guestbook Contest
		(c) 2003 by Firebird
		
		Dieses Programm ist freie Software. 
		Sie knnen es unter den Bedingungen der GNU General Public License,
		wie von der Free Software Foundation verffentlicht,
		weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz
		oder (nach Ihrer Option) jeder spteren Version. 
		
		Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
		da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
		sogar ohne die implizite Garantie der MARKTREIFE oder der
		VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in
		der GNU General Public License. 
	*/
	
	require("global.php");
	
	// Daily Mail Information
	if($Settings['dailyupdate'] == 1 && $Settings['adminmail'] != "")
	{
		$curdatehash = date("dmy");
		if(!isset($Settings['dailyhash']) || $Settings['dailyhash']  != $curdatehash)
		{
			// Ein neuer Tag ist da. Datum in den Settings speichern...
			$Settings['dailyhash'] = $curdatehash;
			saveSettings();
			
			// Mail versenden
			$beitragCount = count($Entrys);
			$beitragNeu = 0;
			foreach($Entrys as $Entry)
				if($Entry['Time'] > mktime(0, 0, 0, date("m"), date ("d") - 1, date("Y")))
					$beitragNeu += 1;
			
			eval("\$confirmmail = \"".getTPL("mail_daily")."\";");
			mail($Settings['adminmail'], "Beitragsbersicht", $confirmmail, "Content-Type: text/html\nFrom: Firebook");
		}
	}
	
	// Moderation
	if($Settings['moderation'] == 1)
	{
		// Nicht aktivierte Beitrge lschen
		$updateSave = 0;
		foreach($Entrys as $Entrykey => $Entry)
			if(isset($Entry['activationkey']) && $Entry['Time'] + (86400 * 30) < time())
			{
				unset($Entrys[$Entrykey]);
				$updateSave = 1;
			}
		if($updateSave == 1) saveSettings();
		
		// Lokale Arbeitskopie erstellen
		$Entrys = $data['ENTRYS'];
		
		// Nicht moderierte Beitrge ausblenden
		foreach($Entrys as $Entrykey => $Entry)
			if(isset($Entry['activationkey'])) 
				unset($Entrys[$Entrykey]);
			
	}
	
	// Seitenzahlen & Seitenkontrolle
	if(!isset($_GET['page'])) $_GET['page'] = 1;
	
	// Seitenzahl errechnen
	$viewPerPage = $Settings['perpage'];
	$entryCount = count($Entrys);
	$Pages = ceil($entryCount / $viewPerPage);
	$Page = $_GET['page'];
	if($Page > $Pages) $Page = $Pages;
	
	if($Page > 4) $Start = (floor($Page / 5) * 5) - 1; else $Start = 1;
	
	// Seitenzahlansicht erstellen
	$Pageslist = "";
	for($currpage=$Start;$currpage<$Start+6;$currpage++)
		if($currpage<=$Pages) eval("\$Pageslist .= \"".($currpage == $Page ? getTPL("mainview_page_current") : getTPL("mainview_page"))."\";");
	
	// Letzte und nchste Seite fr die Templates speichern
	$Prevpage = ($Page > 1 ? $Page - 1 : 1);
	$Nextpage = ($Page < $Pages ? $Page + 1 : $Page);
	
	// Beitrge anzeigen
	if($entryCount > 0)
	{
		// Array ggf. umdrehen um neuste Beitrge oben zu haben
		if($Settings['order'] == 1) 
			$showEntrys = array_reverse($Entrys, true);
		else 
			$showEntrys = $Entrys;
		
		$messages = "";
		reset($showEntrys);
		if ($Page != 1) for($i=0;$i<(($Page - 1) * $viewPerPage);$i++) next($showEntrys);	
		for($i=0;$i<$viewPerPage;$i++)
		{			
			// Entry parsen (Siehe functions.php)
			$messages .= parseEntry(current($showEntrys), key($showEntrys));
			if(!next($showEntrys)) break;
		}
	}
		
	// Seite anzeigen
	eval("echo(\"".getTPL("header")."\");");
	eval("echo(\"".getTPL("mainview")."\");");
	eval("echo(\"".getTPL("footer")."\");");
	
?>